<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BomRevision StructType
 * @subpackage Structs
 */
class BomRevision extends Record
{
    /**
     * The customForm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecordRef
     */
    public $customForm;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The createdDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $createdDate;
    /**
     * The billOfMaterials
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\RecordRef
     */
    public $billOfMaterials;
    /**
     * The memo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $memo;
    /**
     * The isInactive
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $isInactive;
    /**
     * The effectiveStartDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $effectiveStartDate;
    /**
     * The effectiveEndDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $effectiveEndDate;
    /**
     * The componentList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BomRevisionComponentList
     */
    public $componentList;
    /**
     * The customFieldList
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomFieldList
     */
    public $customFieldList;
    /**
     * The internalId
     * @var string
     */
    public $internalId;
    /**
     * The externalId
     * @var string
     */
    public $externalId;
    /**
     * Constructor method for BomRevision
     * @uses BomRevision::setCustomForm()
     * @uses BomRevision::setName()
     * @uses BomRevision::setCreatedDate()
     * @uses BomRevision::setBillOfMaterials()
     * @uses BomRevision::setMemo()
     * @uses BomRevision::setIsInactive()
     * @uses BomRevision::setEffectiveStartDate()
     * @uses BomRevision::setEffectiveEndDate()
     * @uses BomRevision::setComponentList()
     * @uses BomRevision::setCustomFieldList()
     * @uses BomRevision::setInternalId()
     * @uses BomRevision::setExternalId()
     * @param \StructType\RecordRef $customForm
     * @param string $name
     * @param string $createdDate
     * @param \StructType\RecordRef $billOfMaterials
     * @param string $memo
     * @param bool $isInactive
     * @param string $effectiveStartDate
     * @param string $effectiveEndDate
     * @param \StructType\BomRevisionComponentList $componentList
     * @param \StructType\CustomFieldList $customFieldList
     * @param string $internalId
     * @param string $externalId
     */
    public function __construct(\StructType\RecordRef $customForm = null, $name = null, $createdDate = null, \StructType\RecordRef $billOfMaterials = null, $memo = null, $isInactive = null, $effectiveStartDate = null, $effectiveEndDate = null, \StructType\BomRevisionComponentList $componentList = null, \StructType\CustomFieldList $customFieldList = null, $internalId = null, $externalId = null)
    {
        $this
            ->setCustomForm($customForm)
            ->setName($name)
            ->setCreatedDate($createdDate)
            ->setBillOfMaterials($billOfMaterials)
            ->setMemo($memo)
            ->setIsInactive($isInactive)
            ->setEffectiveStartDate($effectiveStartDate)
            ->setEffectiveEndDate($effectiveEndDate)
            ->setComponentList($componentList)
            ->setCustomFieldList($customFieldList)
            ->setInternalId($internalId)
            ->setExternalId($externalId);
    }
    /**
     * Get customForm value
     * @return \StructType\RecordRef|null
     */
    public function getCustomForm()
    {
        return $this->customForm;
    }
    /**
     * Set customForm value
     * @param \StructType\RecordRef $customForm
     * @return \StructType\BomRevision
     */
    public function setCustomForm(\StructType\RecordRef $customForm = null)
    {
        $this->customForm = $customForm;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\BomRevision
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get createdDate value
     * @return string|null
     */
    public function getCreatedDate()
    {
        return $this->createdDate;
    }
    /**
     * Set createdDate value
     * @param string $createdDate
     * @return \StructType\BomRevision
     */
    public function setCreatedDate($createdDate = null)
    {
        // validation for constraint: string
        if (!is_null($createdDate) && !is_string($createdDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createdDate, true), gettype($createdDate)), __LINE__);
        }
        $this->createdDate = $createdDate;
        return $this;
    }
    /**
     * Get billOfMaterials value
     * @return \StructType\RecordRef|null
     */
    public function getBillOfMaterials()
    {
        return $this->billOfMaterials;
    }
    /**
     * Set billOfMaterials value
     * @param \StructType\RecordRef $billOfMaterials
     * @return \StructType\BomRevision
     */
    public function setBillOfMaterials(\StructType\RecordRef $billOfMaterials = null)
    {
        $this->billOfMaterials = $billOfMaterials;
        return $this;
    }
    /**
     * Get memo value
     * @return string|null
     */
    public function getMemo()
    {
        return $this->memo;
    }
    /**
     * Set memo value
     * @param string $memo
     * @return \StructType\BomRevision
     */
    public function setMemo($memo = null)
    {
        // validation for constraint: string
        if (!is_null($memo) && !is_string($memo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($memo, true), gettype($memo)), __LINE__);
        }
        $this->memo = $memo;
        return $this;
    }
    /**
     * Get isInactive value
     * @return bool|null
     */
    public function getIsInactive()
    {
        return $this->isInactive;
    }
    /**
     * Set isInactive value
     * @param bool $isInactive
     * @return \StructType\BomRevision
     */
    public function setIsInactive($isInactive = null)
    {
        // validation for constraint: boolean
        if (!is_null($isInactive) && !is_bool($isInactive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isInactive, true), gettype($isInactive)), __LINE__);
        }
        $this->isInactive = $isInactive;
        return $this;
    }
    /**
     * Get effectiveStartDate value
     * @return string|null
     */
    public function getEffectiveStartDate()
    {
        return $this->effectiveStartDate;
    }
    /**
     * Set effectiveStartDate value
     * @param string $effectiveStartDate
     * @return \StructType\BomRevision
     */
    public function setEffectiveStartDate($effectiveStartDate = null)
    {
        // validation for constraint: string
        if (!is_null($effectiveStartDate) && !is_string($effectiveStartDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($effectiveStartDate, true), gettype($effectiveStartDate)), __LINE__);
        }
        $this->effectiveStartDate = $effectiveStartDate;
        return $this;
    }
    /**
     * Get effectiveEndDate value
     * @return string|null
     */
    public function getEffectiveEndDate()
    {
        return $this->effectiveEndDate;
    }
    /**
     * Set effectiveEndDate value
     * @param string $effectiveEndDate
     * @return \StructType\BomRevision
     */
    public function setEffectiveEndDate($effectiveEndDate = null)
    {
        // validation for constraint: string
        if (!is_null($effectiveEndDate) && !is_string($effectiveEndDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($effectiveEndDate, true), gettype($effectiveEndDate)), __LINE__);
        }
        $this->effectiveEndDate = $effectiveEndDate;
        return $this;
    }
    /**
     * Get componentList value
     * @return \StructType\BomRevisionComponentList|null
     */
    public function getComponentList()
    {
        return $this->componentList;
    }
    /**
     * Set componentList value
     * @param \StructType\BomRevisionComponentList $componentList
     * @return \StructType\BomRevision
     */
    public function setComponentList(\StructType\BomRevisionComponentList $componentList = null)
    {
        $this->componentList = $componentList;
        return $this;
    }
    /**
     * Get customFieldList value
     * @return \StructType\CustomFieldList|null
     */
    public function getCustomFieldList()
    {
        return $this->customFieldList;
    }
    /**
     * Set customFieldList value
     * @param \StructType\CustomFieldList $customFieldList
     * @return \StructType\BomRevision
     */
    public function setCustomFieldList(\StructType\CustomFieldList $customFieldList = null)
    {
        $this->customFieldList = $customFieldList;
        return $this;
    }
    /**
     * Get internalId value
     * @return string|null
     */
    public function getInternalId()
    {
        return $this->internalId;
    }
    /**
     * Set internalId value
     * @param string $internalId
     * @return \StructType\BomRevision
     */
    public function setInternalId($internalId = null)
    {
        // validation for constraint: string
        if (!is_null($internalId) && !is_string($internalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($internalId, true), gettype($internalId)), __LINE__);
        }
        $this->internalId = $internalId;
        return $this;
    }
    /**
     * Get externalId value
     * @return string|null
     */
    public function getExternalId()
    {
        return $this->externalId;
    }
    /**
     * Set externalId value
     * @param string $externalId
     * @return \StructType\BomRevision
     */
    public function setExternalId($externalId = null)
    {
        // validation for constraint: string
        if (!is_null($externalId) && !is_string($externalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalId, true), gettype($externalId)), __LINE__);
        }
        $this->externalId = $externalId;
        return $this;
    }
}
